import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class RCPM_Main {

	public static void main(String[] args) throws Exception {
		
		String projName="./input/cregapi";
		String code= "CR-";
		Scanner s = new Scanner(System.in);
		PrintWriter writer = new PrintWriter(new FileOutputStream(new File("output_final.csv"), true));
		writer.println("To Requirement;From Requirement;Internal probability to change;External propagation factor;Co-Change;Overlapping Contracts;Direct Ripple Effects;Indirect Ripple Effects;Total Change Proneness");
		writer.close();
		
		try {
			RequirementsList rList = new RequirementsList(code);
			rList.populateRequirements(projName + "_internal.csv");
			rList.calculateClassDependencies(projName + ".txt");
			rList.writeFile();
			
			System.out.print("Enter to Requirement (The one you want to assess / all for change proneness): ");
			String toRequirement = s.nextLine();
			System.out.print("Enter from Requirement (ReqID for the ripple effect / all for change proneness): ");
			String fromRequirement = s.nextLine();

			String toFlag =  toRequirement;
			String fromFlag =  fromRequirement;
			
			
			if (toFlag.equals("all")) {
				// TO Requirement equals ALL
				for (int e=0;e<rList.size();e++) {
					toRequirement = rList.get(e).getID();
			
					if (fromFlag.equals("all")) {
						// FROM Requirement equals ALL
						for (int i=0;i<rList.size();i++) {
							writer = new PrintWriter(new FileOutputStream(new File("output_final.csv"), true));
							fromRequirement = rList.get(i).getID();
							if (fromRequirement.equals(toRequirement)==false) {

								Double e1 = rList.getCoChangeProbability(fromRequirement, toRequirement);
								//System.out.println("1");
								Double e2 = rList.getOverlappingContractsProbability(fromRequirement, toRequirement);
								//System.out.println("2");
								Double e31 = rList.getDirectRippleEffects(fromRequirement, toRequirement, projName + "_rem.csv");
								//System.out.println("3");
								Double e32 = rList.getIndirectRippleEffects(fromRequirement, toRequirement, projName + "_rem.csv"); 
								//System.out.println("4");
								
								Double internal = rList.getInternalProbability(toRequirement);
								//System.out.println("5");
								
								Double e_total = e1 + e2 - e1 * e2;
								e_total = e_total + e31 - e31 * e_total;
								e_total = e_total + e32 - e32 * e_total;
								Double cp = internal + e_total - internal* e_total;
							
								System.out.println("\n\nChange Impact Analysis for: " + fromRequirement + " emmiting changes to " + toRequirement);
								System.out.println("-----------------------------------------------------------------");
								System.out.println("Internal probability to change of (" + toRequirement + "): " + String.format( "%.3f", internal * 100) + "%");
								System.out.println("-----------------------------------------------------------------");
								System.out.println("External propagation factor: " + String.format( "%.3f", e_total * 100) + "%");
								System.out.println("\t Co-Change: " + String.format( "%.3f", e1* 100) + "%");			
								System.out.println("\t Overlapping Contracts: " + String.format( "%.3f", e2* 100) + "%");			
								System.out.println("\t Direct Ripple Effects: " + String.format( "%.3f", e31* 100) + "%");			
								System.out.println("\t Indirect Ripple Effects: " + String.format( "%.3f", e32* 100) + "%");			
								System.out.println("-----------------------------------------------------------------");
								System.out.println("Total Change Proneness of (" + toRequirement + "): " + String.format( "%.3f", cp * 100) + "%");
								System.out.println("-----------------------------------------------------------------"); 					
							
								writer.println(toRequirement + ";" + fromRequirement + ";" + String.format( "%.3f", internal * 100) + "%;" + String.format( "%.3f", e_total * 100) + "%;" + String.format( "%.3f", e1* 100) + "%;" + String.format( "%.3f", e2* 100) + "%;" + String.format( "%.3f", e31* 100) + "%;" + String.format( "%.3f", e32* 100) + "%;" + String.format( "%.3f", cp * 100) + "%"); 
								writer.close();	
							}					
						}
					} else {
						
						writer = new PrintWriter(new FileOutputStream(new File("output_final.csv"), true));
						// FROM Requirement equals SPECIFIC
						Double e1 = rList.getCoChangeProbability(fromRequirement, toRequirement);
						Double e2 = rList.getOverlappingContractsProbability(fromRequirement, toRequirement);
						Double e31 = rList.getDirectRippleEffects(fromRequirement, toRequirement, projName + "_rem.csv");
						Double e32 = rList.getIndirectRippleEffects(fromRequirement, toRequirement, projName + "_rem.csv");
					
						Double internal = rList.getInternalProbability(toRequirement);
						Double e_total = e1 + e2 - e1 * e2;
						e_total = e_total + e31 - e31 * e_total;
						e_total = e_total + e32 - e32 * e_total;
						Double cp = internal + e_total - internal* e_total;
					
						System.out.println("\n\nChange Impact Analysis for: " + fromRequirement + " emmiting changes to " + toRequirement);
						System.out.println("-----------------------------------------------------------------");
						System.out.println("Internal probability to change of (" + toRequirement + "): " + String.format( "%.3f", internal * 100) + "%");
						System.out.println("-----------------------------------------------------------------");
						System.out.println("External propagation factor: " + String.format( "%.3f", e_total * 100) + "%");
						System.out.println("\t Co-Change: " + String.format( "%.3f", e1* 100) + "%");			
						System.out.println("\t Overlapping Contracts: " + String.format( "%.3f", e2* 100) + "%");			
						System.out.println("\t Direct Ripple Effects: " + String.format( "%.3f", e31* 100) + "%");			
						System.out.println("\t Indirect Ripple Effects: " + String.format( "%.3f", e32* 100) + "%");			
						System.out.println("-----------------------------------------------------------------");
						System.out.println("Total Change Proneness of (" + toRequirement + "): " + String.format( "%.3f", cp * 100) + "%");
						System.out.println("-----------------------------------------------------------------");
						
						writer.println(toRequirement + ";" + fromRequirement + ";" + String.format( "%.3f", internal * 100) + "%;" + String.format( "%.3f", e_total * 100) + "%;" + String.format( "%.3f", e1* 100) + "%;" + String.format( "%.3f", e2* 100) + "%;" + String.format( "%.3f", e31* 100) + "%;" + String.format( "%.3f", e32* 100) + "%;" + String.format( "%.3f", cp * 100) + "%");
						writer.close();
						
					}
				}
			} else {
				// TO Requirement equals SPECIFIC
				if (fromFlag.equals("all")) {
					// FROM Requirement equals ALL
					for (int i=0;i<rList.size();i++) {
						writer = new PrintWriter(new FileOutputStream(new File("output_final.csv"), true));
						fromRequirement = rList.get(i).getID();
						if (fromRequirement.equals(toRequirement)==false) {
							Double e1 = rList.getCoChangeProbability(fromRequirement, toRequirement);
							Double e2 = rList.getOverlappingContractsProbability(fromRequirement, toRequirement);
							Double e31 = rList.getDirectRippleEffects(fromRequirement, toRequirement, projName + "_rem.csv");
							Double e32 = rList.getIndirectRippleEffects(fromRequirement, toRequirement, projName + "_rem.csv");
						
							Double internal = rList.getInternalProbability(toRequirement);
							Double e_total = e1 + e2 - e1 * e2;
							e_total = e_total + e31 - e31 * e_total;
							e_total = e_total + e32 - e32 * e_total;
							Double cp = internal + e_total - internal* e_total;
						
							System.out.println("\n\nChange Impact Analysis for: " + fromRequirement + " emmiting changes to " + toRequirement);
							System.out.println("-----------------------------------------------------------------");
							System.out.println("Internal probability to change of (" + toRequirement + "): " + String.format( "%.3f", internal * 100) + "%");
							System.out.println("-----------------------------------------------------------------");
							System.out.println("External propagation factor: " + String.format( "%.3f", e_total * 100) + "%");
							System.out.println("\t Co-Change: " + String.format( "%.3f", e1* 100) + "%");			
							System.out.println("\t Overlapping Contracts: " + String.format( "%.3f", e2* 100) + "%");			
							System.out.println("\t Direct Ripple Effects: " + String.format( "%.3f", e31* 100) + "%");			
							System.out.println("\t Indirect Ripple Effects: " + String.format( "%.3f", e32* 100) + "%");			
							System.out.println("-----------------------------------------------------------------");
							System.out.println("Total Change Proneness of (" + toRequirement + "): " + String.format( "%.3f", cp * 100) + "%");
							System.out.println("-----------------------------------------------------------------");					
						
							writer.println(toRequirement + ";" + fromRequirement + ";" + String.format( "%.3f", internal * 100) + "%;" + String.format( "%.3f", e_total * 100) + "%;" + String.format( "%.3f", e1* 100) + "%;" + String.format( "%.3f", e2* 100) + "%;" + String.format( "%.3f", e31* 100) + "%;" + String.format( "%.3f", e32* 100) + "%;" + String.format( "%.3f", cp * 100) + "%");
							writer.close();	
						}					
					}
				} else {
					// FROM Requirement equals SPECIFIC	
					writer = new PrintWriter(new FileOutputStream(new File("output_final.csv"), true));
					Double e1 = rList.getCoChangeProbability(fromRequirement, toRequirement);
					Double e2 = rList.getOverlappingContractsProbability(fromRequirement, toRequirement);
					Double e31 = rList.getDirectRippleEffects(fromRequirement, toRequirement, projName + "_rem.csv");
					Double e32 = rList.getIndirectRippleEffects(fromRequirement, toRequirement, projName + "_rem.csv");
				
					Double internal = rList.getInternalProbability(toRequirement);
					Double e_total = e1 + e2 - e1 * e2;
					e_total = e_total + e31 - e31 * e_total;
					e_total = e_total + e32 - e32 * e_total;
					Double cp = internal + e_total - internal* e_total;
				
					System.out.println("\n\nChange Impact Analysis for: " + fromRequirement + " emmiting changes to " + toRequirement);
					System.out.println("-----------------------------------------------------------------");
					System.out.println("Internal probability to change of (" + toRequirement + "): " + String.format( "%.3f", internal * 100) + "%");
					System.out.println("-----------------------------------------------------------------");
					System.out.println("External propagation factor: " + String.format( "%.3f", e_total * 100) + "%");
					System.out.println("\t Co-Change: " + String.format( "%.3f", e1* 100) + "%");			
					System.out.println("\t Overlapping Contracts: " + String.format( "%.3f", e2* 100) + "%");			
					System.out.println("\t Direct Ripple Effects: " + String.format( "%.3f", e31* 100) + "%");			
					System.out.println("\t Indirect Ripple Effects: " + String.format( "%.3f", e32* 100) + "%");			
					System.out.println("-----------------------------------------------------------------");
					System.out.println("Total Change Proneness of (" + toRequirement + "): " + String.format( "%.3f", cp * 100) + "%");
					System.out.println("-----------------------------------------------------------------");
					
					writer.println(toRequirement + ";" + fromRequirement + ";" + String.format( "%.3f", internal * 100) + "%;" + String.format( "%.3f", e_total * 100) + "%;" + String.format( "%.3f", e1* 100) + "%;" + String.format( "%.3f", e2* 100) + "%;" + String.format( "%.3f", e31* 100) + "%;" + String.format( "%.3f", e32* 100) + "%;" + String.format( "%.3f", cp * 100) + "%");
					writer.close();
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println("\n\n\n\n Process Finished!!!");
	}
}
